## re2c 0.9.1

=== Makefile ===
# $Log: Makefile,v $
#Revision 1.1  1994/04/08  16:30:37  peter
#Initial revision
#

BIN = /usr/local/bin
MAN = /usr/local/man

%.o : %.cc ; $(CC) -o $@ $(CFLAGS) -c $<
%.cc : %.y ; $(YACC)  $(YFLAGS) $<; mv $(YTAB).c $@
%.cc : %.l ; $(LEX)   $(LFLAGS) $<; mv $(LEXYY).c $@

%.cc:	%.re
	re2c -s $< >$@

SOURCES	= code.cc dfa.cc main.cc parser.y actions.cc scanner.re substr.cc\
	translate.cc
OBJS	= code.o dfa.o main.o parser.o actions.o scanner.o substr.o\
	translate.o

CC		= g++
CFLAGS		= -O2 -Wall -I. -Wno-unused -Wno-parentheses
YFLAGS		= -d
LDFLAGS		= 

default:	re2c

clean:
	rm -f *.o *.s y.tab.c y.tab.h scanner.cc parser.cc .version version.h re2c

parser.cc:	parser.y
	yacc -d parser.y
	mv -f y.tab.c parser.cc

re2c:	$(OBJS)
	$(CC) -o $@ $(OBJS) $(LDFLAGS) -lstdc++

.version: README
	egrep "^Version" README | sed 's/Version //' > .version

version.h: .version
	echo "#define RE2C_VERSION" `cat .version` > version.h

install: re2c
	install -d $(BIN)
	install -s re2c $(BIN)
	install -d $(MAN)/man1
	install -m 0644 re2c.1 $(MAN)/man1

dist: re2c scanner.cc .version
	mkdir re2c-`cat .version`
	cp -P `p4 files ... | sed s/\\\\/\\\\/depot\\\\/home\\\\/re2c\\\\/// | sed '/- delete/d' | sed s/#.*$$//` re2c-`cat .version`/
	tar zcf re2c-`cat .version`.tar.gz re2c-`cat .version`/
	rm -rf re2c-`cat .version`

#
# generated with "gcc -I. -MM -x c++ *.cc *.y *.re"
# and edited by hand
#
actions.o : actions.cc globals.h basics.h parser.h scanner.h \
  token.h substr.h re.h ins.h dfa.h 
code.o : code.cc substr.h basics.h globals.h dfa.h re.h token.h \
  ins.h 
dfa.o : dfa.cc globals.h basics.h substr.h dfa.h re.h token.h \
  ins.h 
main.o : main.cc globals.h basics.h parser.h scanner.h token.h \
  substr.h re.h ins.h dfa.h version.h
substr.o : substr.cc substr.h basics.h 
translate.o : translate.cc globals.h basics.h 
scanner.o : scanner.re scanner.h token.h substr.h basics.h \
  parser.h re.h ins.h ./parser.o
parser.o : parser.y globals.h basics.h parser.h scanner.h token.h \
  substr.h re.h ins.h

## re2c 0.16

=== debian/changelog ===
re2c (0.16-1) unstable; urgency=medium

  * New upstream release:
    + Fixes test failures on big endian archs. (LP: #1531563)
  * Rules: ensure failed tests are visible in the buildlog.
  * Drop patch 01, merged upstream.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Fri, 22 Jan 2016 10:26:19 +0000

re2c (0.15.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #747184)
  * New maintainer. (Closes: #808410)
  * Add d/source/format, set to 3.0 (quilt).
  * Control:
    + Set debhelper version (and d/compat) to 9.
    + Add missing ${misc:Depends} dependency to the binary package.
    + Add VCS links.
    + Change upstream homepage to re2c.org.
    + Description: remove needless dot from the end, stop using first
      person.
  * Copyright: update list of upstream authors.
  * Docs: don't install README, not relevant for end users and
    duplicating info already in the packaging.
  * Rules: convert to dh sequencer.
  * Examples: don't install "lessons", removed upstream.
  * Bump standards-version to 3.9.6 (from 3.8.0), no further changes.
  * Add patch 01: fix typos in manpage and usage info.
  * Watch: escape dot in version matching regexp.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 21 Dec 2015 07:55:14 +0000

re2c (0.13.5-1) unstable; urgency=low

  * New upstream release; closes: #486598.
  * Update to Standards-Version: 3.8.0.

 -- Robert S. Edmonds <edmonds@debian.org>  Thu, 17 Jul 2008 16:08:56 -0400

re2c (0.13.3-1) unstable; urgency=low

  * New upstream release; closes: #472003.

 -- Robert S. Edmonds <edmonds@debian.org>  Tue, 01 Apr 2008 16:16:59 -0400

re2c (0.12.1-1) unstable; urgency=low

  * New upstream release, closes: #416697.
  * New maintainer, closes: #320283.

 -- Robert S. Edmonds <edmonds@debian.org>  Sun, 27 May 2007 19:56:53 -0400

re2c (0.9.12-2) unstable; urgency=low

  * QA upload.
  * re.h: Add forward declaration for gcc 4.1.  Thanks to Martin Michlmayr
    for the patch.  Closes:  #356168.

 -- Matej Vela <vela@debian.org>  Fri, 10 Mar 2006 08:20:45 +0100

re2c (0.9.12-1) unstable; urgency=low

  * QA upload.
  * New upstream release.  Closes: #348983.

 -- Matej Vela <vela@debian.org>  Sat, 21 Jan 2006 22:22:46 +0100

re2c (0.9.10-2) unstable; urgency=low

  [ QA Group upload ]
  * debian/changelog: restore 0.9.1-7 changelog entry
  * debian/rules:
    - remove -I. from CFLAGS (redundant)
    - remove INSTALL* cruft (not used)
    - touch build-stamp to prevent running the tests twice
    - use make distclean is buggy, so do the equivalent of it using rm
    - add binary-indep target as it is required by policy
    - re2c.1 already installed by upstream
  * debian/watch:
    - use version=2 for dehs compatability
    - quote .tar.gz

 -- Paul Wise <pabs3@bonedaddy.net>  Tue, 18 Oct 2005 17:41:50 +0800

re2c (0.9.10-1) unstable; urgency=low

  [ QA Group upload ]
  * New upstream release
  * Add Homepage to package description

 -- Paul Wise <pabs3@bonedaddy.net>  Tue, 18 Oct 2005 17:02:17 +0800

re2c (0.9.9-2) unstable; urgency=low

  [ QA Group upload ]
  * Clean the source tree properly
  * Remove prerm/postinst
  * Strip binaries properly
  * Fix examples permissions

 -- Paul Wise <pabs3@bonedaddy.net>  Thu,  1 Sep 2005 13:01:08 +0800

re2c (0.9.9-1) unstable; urgency=low

  [ QA Group upload ]
  * New upstream release (Closes: #300923)
  * Add watch file
  * Update to latest standards version (no changes)
  * Modernise debian/rules
  * Run tests during build
  * Update debian/copyright

 -- Paul Wise <pabs3@bonedaddy.net>  Fri, 19 Aug 2005 15:10:37 +0800

re2c (0.9.1-7) unstable; urgency=low

  * QA Group upload orphaning this package

 -- Andrew Pollock <apollock@debian.org>  Wed,  7 Sep 2005 09:47:06 +1000

re2c (0.9.1-6) unstable; urgency=high

  * The bootstrapping system was broken by the last upload.  This upload
    corrects the bootstrap path, and yacc and re2c paths should work as well.

 -- Daniel Bungert <drb@debian.org>  Thu,  2 Sep 2004 23:55:31 -0400

re2c (0.9.1-5) unstable; urgency=high

  * Apply workaround from  LaMont Jones <lamont@mmjgroup.com> for race
    condition in build scripts. (Closes: #259337, #268673)

 -- Daniel Bungert <drb@debian.org>  Wed,  1 Sep 2004 20:51:21 -0400

re2c (0.9.1-4) unstable; urgency=low

  * Apply workaround from Serge Semashko <ss@vba.com.by> to remove
    some useless compilier warnings (warning: label 'foo' defined but
    not used) in generated code.
  * Now builds with g++-3.3.
  * Build with g++3.3 for c102 transition.  (Closes: #236115)
  * Standards version 3.6.1

 -- Daniel Bungert <drb@debian.org>  Thu, 04 Mar 2004 20:36:19 -0500 

re2c (0.9.1-3) unstable; urgency=low

  * More debian/rules cleaning.
  * Remove bogus build-dep.

 -- Daniel Bungert <drb@debian.org>  Fri, 08 Mar 2002 11:19:19 -0500

re2c (0.9.1-2) unstable; urgency=low

  * Now builds with g++-3.
  * A little debian/rules cleaning.

 -- Daniel Bungert <drb@debian.org>  Sun, 11 Nov 2001 15:17:26 -0500 

re2c (0.9.1-1) unstable; urgency=low

  * Initial Release. (Closes: #113641)

 -- Daniel Bungert <drb@debian.org>  Sun, 16 Sep 2001 01:35:17 -0400

=== debian/control ===
Source: re2c
Section: devel
Priority: optional
Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
Build-Depends: debhelper (>= 9), bison
Standards-Version: 3.9.6
Homepage: http://re2c.org
Vcs-Git: git://github.com/jcfp/debpkg-re2c.git
Vcs-Browser: https://github.com/jcfp/debpkg-re2c/

Package: re2c
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool for generating fast C-based recognizers
 re2c is a great tool for writing fast and flexible lexers. Unlike 
 other such tools, re2c concentrates solely on generating efficient
 code for matching regular expressions. Not only does this singleness
 make re2c more suitable for a wider variety of applications, it
 allows one to generate scanners which approach hand-crafted ones in
 terms of size and speed.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_installexamples:
	dh_installexamples -Xwindows

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_auto_test:
	# ensure failed tests are visible in the buildlog
	$(MAKE) check || /bin/sh -c 'cat test-suite.log; false'

=== debian/watch ===
version=3
http://sf.net/re2c/re2c-([\d\.]*)\.tar\.gz

## re2c 1.0.1

=== debian/changelog ===
re2c (1.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Control: mark package multi-arch: foreign. (Closes: #865011)
  * Bump Standards-Version to 4.1.0.0 (from 3.9.8; no further changes).
  * Patches:
    + Remove 01, merged upstream.
    + Update 02 to catch fresh new typos.
  * Compat: bump to 10 (from 9) and set debhelper version accordingly.
  * Rules:
    + simplify dh_auto_test override.
    + exclude all examples from compression.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 22 Aug 2017 15:27:17 +0000

re2c (0.16-2) unstable; urgency=medium

  * Control: switch Vcs-Git url to https.
  * Rules:
    + enable all hardening options.
    + don't run tests when crosscompiling; patch courtesy of Helmut
      Grohne. (Closes: #843217)
    + tweak compression of examples for consistency. (Closes: #849575)
  * Watch: switch to github, upstream only keeps sf.net around as a
    backup.
  * Patches:
    + add 01: fix segvault with null input, backported from upstream
      commit 54711f6. (Closes: #823999)
    + add 02: correct some minor typos in the manpage.
  * Bump Standards-Version to 3.9.8 (from 3.9.6, no further changes).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 10 Jan 2017 10:23:58 +0000

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: devel
 Priority: optional
 Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
-Build-Depends: debhelper (>= 9), bison
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 10), bison
+Standards-Version: 4.1.0.0
 Homepage: http://re2c.org
-Vcs-Git: git://github.com/jcfp/debpkg-re2c.git
+Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
 Vcs-Browser: https://github.com/jcfp/debpkg-re2c/
 
 Package: re2c
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: tool for generating fast C-based recognizers
  re2c is a great tool for writing fast and flexible lexers. Unlike

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installexamples:
	dh_installexamples -Xwindows

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_auto_test:
	dh_auto_test
	# ensure failed tests are visible in the buildlog
	/bin/sh -c 'cat test-suite.log || true'

override_dh_compress:
	dh_compress -X examples/

## re2c 1.1.1

=== debian/changelog ===
re2c (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.1 (from 4.1.0; no further changes).
  * Set compat level and debhelper build-dep version to 11.
  * Patches:
    + refresh 02.
    + add 03_backported_fix_upstream_issue_215.
  * Remove trailing whitespaces from d/{changelog,control}.
  * Copyright:
    + convert to machine-readable format.
    + add entries for some of the test files.
  * Tests: add initial autopkgtest, using upstream test suite.
  * Lintian: override license-problem-php-license and
    override_dh_auto_test-does-not-check-DEB_BUILD_OPTIONS: both false
    positives.
  * Rules: remove overrides for dh_installexamples (excluded files no
    longer shipped upstream) and dh_installchangelogs (file is found
    automagically now).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Wed, 03 Oct 2018 08:41:27 +0000

=== debian/control ===
Source: re2c
Section: devel
Priority: optional
Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
Build-Depends: debhelper (>= 11), bison
Standards-Version: 4.2.1
Homepage: http://re2c.org
Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
Vcs-Browser: https://github.com/jcfp/debpkg-re2c/

Package: re2c
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool for generating fast C-based recognizers
 re2c is a great tool for writing fast and flexible lexers. Unlike
 other such tools, re2c concentrates solely on generating efficient
 code for matching regular expressions. Not only does this singleness
 make re2c more suitable for a wider variety of applications, it
 allows one to generate scanners which approach hand-crafted ones in
 terms of size and speed.

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,6 @@
 %:
 	dh $@
 
-override_dh_installexamples:
-	dh_installexamples -Xwindows
-
-override_dh_installchangelogs:
-	dh_installchangelogs CHANGELOG
-
 override_dh_auto_test:
 	dh_auto_test
 	# ensure failed tests are visible in the buildlog

=== debian/watch ===
version=3
https://github.com/skvadrik/re2c/releases .*/re2c-(\d\S*)\.tar\.gz

## re2c 1.2.1

=== debian/changelog ===
re2c (1.2.1-1ubuntu0.1) eoan-security; urgency=medium

  * SECURITY UPDATE: Heap-based buffer overflow
    - debian/patches/CVE-2020-11958.patch: fix calculation
      of the shift offset in src/parse/scanner.cc.
    - CVE-2020-11958

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 21 Apr 2020 11:06:43 -0300

re2c (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Watch: extend extensions for releases beyond just ".tar.gz".
  * Patches:
    + refresh 02 (remove fuzz) and rebase on manpage source files.
    + remove 03 (issue fixed upstream).
  * Copyright: adjust file path for php-releated tests that were moved
    to a subdir.
  * Rules:
    + remove dh_compress override, examples are excluded by default
      with compat 12.
    + override dh_auto_configure: add --enable-docs to generate docs
      during build rather than rely on bootstrapped files.
  * d/docs: remove, sole listed file no longer shipped upstream.
  * Bump compat level to 12 (from 11; no further changes).
  * Bump Standards-Version to 4.4.0 (from 4.2.1; no further changes).
  * Control:
    + use debhelper-compat instead of debian/compat.
    + add build-dep on python3-docutils (needed by --enable-docs).
  * d/clean: add to remove files modified by --enable-docs.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 12 Aug 2019 09:44:08 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,13 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
-Build-Depends: debhelper (>= 11), bison
-Standards-Version: 4.2.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Build-Depends:
+ bison,
+ debhelper-compat (= 12),
+ python3-docutils
+Standards-Version: 4.4.0
 Homepage: http://re2c.org
 Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
 Vcs-Browser: https://github.com/jcfp/debpkg-re2c/

## re2c 1.3

=== debian/changelog ===
re2c (1.3-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Mar 2020 13:29:19 +0100

re2c (1.3-1) unstable; urgency=medium

  [ JCF Ploemen (jcfp) ]
  * New upstream release:
    + makes the build reproducible. (Closes: #934697)
  * Control: switch Vcs fields to salsa.d.o.
  * Patches: remove all, merged upstream.
  * Copyright: account for upstream reshuffling of tests and add entries
    for new tests.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.
  * Bump Standards-Version to 4.4.1 (from 4.4.0; no further changes).

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Wed, 08 Jan 2020 10:57:29 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
 Build-Depends:
  bison,
  debhelper-compat (= 12),
  python3-docutils
-Standards-Version: 4.4.0
-Homepage: http://re2c.org
-Vcs-Git: https://github.com/jcfp/debpkg-re2c.git
-Vcs-Browser: https://github.com/jcfp/debpkg-re2c/
+Standards-Version: 4.4.1
+Homepage: https://re2c.org
+Vcs-Git: https://salsa.debian.org/jcfp-guest/re2c.git
+Vcs-Browser: https://salsa.debian.org/jcfp-guest/re2c
 
 Package: re2c
 Architecture: any

=== debian/tests/control ===
Tests: upstream-runtests
Depends: @, build-essential, debhelper, dh-autoreconf
Restrictions: rw-build-tree

=== debian/watch ===
version=3
https://github.com/skvadrik/re2c/releases .*/re2c-(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## re2c 2.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(re2c VERSION 2.0.3 HOMEPAGE_URL "https://re2c.org/")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Re2cAutotoolsHelpers)
include(Re2cBootstrapLexer)
include(Re2cBootstrapParser)
include(Re2cGenDocs)
include(Re2cTryCXXFlag)

ac_subst(PACKAGE_VERSION "${PROJECT_VERSION}")

option(RE2C_REBUILD_LEXERS "Regenerate lexers" OFF)
if(RE2C_REBUILD_LEXERS AND NOT RE2C_FOR_BUILD)
    message(FATAL_ERROR "need RE2C_FOR_BUILD for RE2C_REBUILD_LEXERS")
endif()

option(RE2C_REBUILD_DOCS "Regenerate manpage" OFF)
if(RE2C_REBUILD_DOCS)
    find_program(RST2MAN NAMES rst2man rst2man.py)
    if(NOT RST2MAN)
        message(FATAL_ERROR "need rst2man or rst2man.py for RE2C_REBUILD_DOCS")
    endif()
endif()

option(RE2C_BUILD_LIBS "Build libraries" OFF)

option(RE2C_BUILD_RE2GO "Build re2go executable (an alias for `re2c --lang go`)" ON)

# checks for programs
find_package(BISON)

# checks for C++ compiler flags
set(CMAKE_CXX_STANDARD 98)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON) # make sure object libraries work with shared libraries
if(NOT CMAKE_BUILD_TYPE)
    try_cxxflag("-O2")
endif()
try_cxxflag("-W")
try_cxxflag("-Wall")
try_cxxflag("-Wextra")
try_cxxflag("-Weffc++")
try_cxxflag("-pedantic")
try_cxxflag("-Wformat=2")
try_cxxflag("-Wredundant-decls")
try_cxxflag("-Wsuggest-attribute=format")
try_cxxflag("-Wconversion")
try_cxxflag("-Wsign-conversion")
try_cxxflag("-Werror=return-type")
try_cxxflag("-Weverything"
    "-Wno-unknown-warning-option" # CLANG eats some GCC options only to warn they are unknown
    "-Wno-reserved-id-macro" # to allow header guards of the form '_RE2C_PATH_TO_HEADER_BASENAME_'
    "-Wno-padded"
    "-Wno-old-style-cast" # RE2C-generated lexer has lots of C-syle casts because of 're2c:yych:conversion = 1;'
    "-Wno-nested-anon-types"
    "-Wno-global-constructors" # initialization of global constants with std::numeric_limits<...> (mostly for size_t)
    "-Wno-shadow-field-in-constructor" # using same names in ctor seems more like a feature
    "-Wno-undefined-func-template" # explicit specialization to reduce build dependencies
)
try_cxxflag("-fdiagnostics-color=always")

# use system stdint.h if present, otherwise fallback to src/c99_stdint.h
ac_check_headers("stdint.h")
# needed for POSIX file API
ac_check_headers("sys/types.h")
ac_check_headers("sys/stat.h")
ac_check_headers("fcntl.h")
ac_check_headers("unistd.h")
# windows POSIX-like API
ac_check_headers("io.h")

# list of possible types to use in typedefs
ac_check_sizeof("char")
ac_check_sizeof("short")
ac_check_sizeof("int")
ac_check_sizeof("long")
ac_check_sizeof("long long")
ac_check_sizeof("__int64")
ac_check_sizeof("void *")
# 64-bit integer constant suffix
ac_check_sizeof("0l")
ac_check_sizeof("0ll")
ac_check_sizeof("0i8")

# docs (manpages and help)
set(re2c_manpage_source       "${CMAKE_CURRENT_BINARY_DIR}/doc/manpage.rst")
set(re2c_help_source          "${CMAKE_CURRENT_BINARY_DIR}/doc/help.rst")
set(re2c_manpage_bootstrap_c  "${CMAKE_CURRENT_SOURCE_DIR}/bootstrap/doc/re2c.1")
set(re2c_manpage_bootstrap_go "${CMAKE_CURRENT_SOURCE_DIR}/bootstrap/doc/re2go.1")
set(re2c_help_bootstrap       "${CMAKE_CURRENT_SOURCE_DIR}/bootstrap/src/msg/help.cc")
set(re2c_manpage_c            "${CMAKE_CURRENT_BINARY_DIR}/doc/re2c.1")
set(re2c_manpage_go           "${CMAKE_CURRENT_BINARY_DIR}/doc/re2go.1")
set(re2c_help                 "${CMAKE_CURRENT_BINARY_DIR}/src/msg/help.cc")
set(re2c_genhelp              "${CMAKE_CURRENT_SOURCE_DIR}/build/gen_help.sh")
set(re2c_splitman             "${CMAKE_CURRENT_SOURCE_DIR}/build/split_man.sh")
set(re2c_docs
    "${re2c_help}"
    "${re2c_manpage_c}"
    "$<$<BOOL:${RE2C_BUILD_RE2GO}>:${re2c_manpage_go}>"
)

set(top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")
configure_file(doc/manpage.rst.in doc/manpage.rst @ONLY)
configure_file(doc/help.rst.in doc/help.rst @ONLY)

configure_file(run_tests.sh.in run_tests.sh @ONLY)
set(RE2C_RUN_TESTS "${CMAKE_CURRENT_BINARY_DIR}/run_tests.sh")
if(CMAKE_HOST_UNIX)
    execute_process(COMMAND chmod +x "${RE2C_RUN_TESTS}")
endif()

ac_config_headers("config.h")

# Makefile.am
set(RE2C_STDLIB_DIR "${CMAKE_INSTALL_PREFIX}/share/re2c/stdlib")
add_compile_definitions(
  "RE2C_STDLIB_DIR=\"${RE2C_STDLIB_DIR}\""
  $<$<CONFIG:Debug>:RE2C_DEBUG>
)
include_directories(. "${CMAKE_CURRENT_BINARY_DIR}")

# Build autogenerated sources into an object library to ensure that they are
# generated once at the beginning of build (as with Automake BUILT_SOURCES).
# WARNING: custom target that depends on autogenerated sources won't do here
# as its dependencies get built multiple times, which ruins parallel builds.
add_library(re2c_objects_autogen OBJECT
    "${CMAKE_CURRENT_BINARY_DIR}/src/parse/parser.cc"
    "${CMAKE_CURRENT_BINARY_DIR}/src/parse/parser.h"
    "${CMAKE_CURRENT_BINARY_DIR}/src/parse/lex.cc"
    "${CMAKE_CURRENT_BINARY_DIR}/src/parse/lex.h"
    "${CMAKE_CURRENT_BINARY_DIR}/src/parse/lex_conf.cc"
    "${CMAKE_CURRENT_BINARY_DIR}/src/options/parse_opts.cc"
    "${re2c_docs}"
)
add_library(re2c_objects_autogen_ver_to_vernum OBJECT
    "${CMAKE_CURRENT_BINARY_DIR}/src/msg/ver_to_vernum.cc"
)

set(re2c_sources
    src/codegen/code_goto.cc
    src/codegen/combine.cc
    src/codegen/gen_bitmaps.cc
    src/codegen/gen_delayed.cc
    src/codegen/gen_dfa.cc
    src/codegen/gen_goto.cc
    src/codegen/gen_program.cc
    src/codegen/gen_state.cc
    src/codegen/helpers.cc
    src/codegen/render.cc
    src/options/opt.cc
    src/nfa/estimate_size.cc
    src/nfa/re_to_nfa.cc
    src/adfa/adfa.cc
    src/adfa/prepare.cc
    src/debug/dump_adfa.cc
    src/debug/dump_cfg.cc
    src/debug/dump_dfa.cc
    src/debug/dump_dfa_tree.cc
    src/debug/dump_interf.cc
    src/debug/dump_nfa.cc
    src/cfg/cfg.cc
    src/cfg/compact.cc
    src/cfg/dce.cc
    src/cfg/freeze.cc
    src/cfg/interfere.cc
    src/cfg/liveanal.cc
    src/cfg/normalize.cc
    src/cfg/optimize.cc
    src/cfg/rename.cc
    src/cfg/varalloc.cc
    src/dfa/closure.cc
    src/dfa/dead_rules.cc
    src/dfa/determinization.cc
    src/dfa/fallback_tags.cc
    src/dfa/fillpoints.cc
    src/dfa/find_state.cc
    src/dfa/minimization.cc
    src/dfa/stacmd.cc
    src/dfa/tagver_table.cc
    src/dfa/tcmd.cc
    src/encoding/ebcdic/ebcdic_regexp.cc
    src/encoding/enc.cc
    src/encoding/range_suffix.cc
    src/encoding/utf8/utf8_regexp.cc
    src/encoding/utf8/utf8.cc
    src/encoding/utf16/utf16_regexp.cc
    src/encoding/utf16/utf16.cc
    src/msg/msg.cc
    src/msg/warn.cc
    src/regexp/ast_to_re.cc
    src/regexp/default_tags.cc
    src/regexp/fixed_tags.cc
    src/regexp/nullable.cc
    src/regexp/rule.cc
    src/regexp/split_charset.cc
    src/regexp/tag.cc
    src/compile.cc
    src/skeleton/control_flow.cc
    src/skeleton/generate_code.cc
    src/skeleton/generate_data.cc
    src/skeleton/maxpath.cc
    src/skeleton/skeleton.cc
    src/parse/ast.cc
    src/parse/input.cc
    src/parse/normalize.cc
    src/parse/scanner.cc
    src/parse/unescape.cc
    src/parse/validate.cc
    src/util/get_dir.cc
    src/util/s_to_n32_unsafe.cc
    src/util/temp_file.cc
    src/util/range.cc
    src/main.cc
    $<TARGET_OBJECTS:re2c_objects_autogen>
    $<TARGET_OBJECTS:re2c_objects_autogen_ver_to_vernum>
)

# re2c
add_executable(re2c ${re2c_sources})

# re2go
if (RE2C_BUILD_RE2GO)
    add_executable(re2go ${re2c_sources})
    target_compile_definitions(re2go PUBLIC "RE2C_LANG=LANG_GO")
endif()

re2c_bootstrap_lexer("src/parse/lex.re" "src/parse/lex.cc" "src/parse/lex.h")
re2c_bootstrap_lexer("src/parse/lex_conf.re" "src/parse/lex_conf.cc")
re2c_bootstrap_lexer("src/options/parse_opts.re" "src/options/parse_opts.cc")
re2c_bootstrap_lexer("src/msg/ver_to_vernum.re" "src/msg/ver_to_vernum.cc")
re2c_bootstrap_parser("src/parse/parser.ypp" "src/parse/parser.cc" "src/parse/parser.h")

# docs
set(re2c_docs_sources
    "${re2c_manpage_source}"
    "doc/manual/api/api.rst_"
    "doc/manual/api/interface.rst_"
    "doc/manual/conditions/conditions.rst_"
    "doc/manual/configurations/configurations.rst_"
    "doc/manual/directives/directives.rst_"
    "doc/manual/dot/dot.rst_"
    "doc/manual/encodings/encodings.rst_"
    "doc/manual/eof/01_sentinel.rst_"
    "doc/manual/eof/02_bounds_checking.rst_"
    "doc/manual/eof/03_eof_rule.rst_"
    "doc/manual/eof/04_generic_api.rst_"
    "doc/manual/eof/eof.rst_"
    "doc/manual/fill/01_fill.rst_"
    "doc/manual/fill/02_fill.rst_"
    "doc/manual/fill/fill.rst_"
    "doc/manual/headers/headers.rst_"
    "doc/manual/includes/includes.rst_"
    "doc/manual/options/debug.rst_"
    "doc/manual/options/internal.rst_"
    "doc/manual/options/options.rst_"
    "doc/manual/regexps/regular_expressions.rst_"
    "doc/manual/reuse/reuse.rst_"
    "doc/manual/skeleton/skeleton.rst_"
    "doc/manual/state/state.rst_"
    "doc/manual/submatch/submatch_example_mtags.rst_"
    "doc/manual/submatch/submatch_example_posix.rst_"
    "doc/manual/submatch/submatch_example_stags.rst_"
    "doc/manual/submatch/submatch.rst_"
    "doc/manual/syntax/syntax.rst_"
    "doc/manual/warnings/warnings_general.rst_"
    "doc/manual/warnings/warnings_list.rst_"
    "examples/c/01_basic.re"
    "examples/c/conditions/parse_u32_conditions.re"
    "examples/c/eof/01_sentinel.re"
    "examples/c/eof/02_bounds_checking.re"
    "examples/c/eof/03_eof_rule.re"
    "examples/c/eof/05_generic_api_eof_rule.re"
    "examples/c/fill/01_fill.re"
    "examples/c/fill/02_fill.re"
    "examples/c/headers/header.re"
    "examples/c/headers/src/lexer/lexer.h"
    "examples/c/includes/include.re"
    "examples/c/includes/definitions.h"
    "examples/c/reuse/reuse.re"
    "examples/c/state/push.re"
    "examples/c/submatch/01_stags.re"
    "examples/c/submatch/02_mtags.re"
    "examples/c/submatch/03_posix.re"
    "examples/go/01_basic.re"
    "examples/go/conditions/parse_u32_conditions.re"
    "examples/go/eof/01_sentinel.re"
    "examples/go/eof/02_bounds_checking.re"
    "examples/go/eof/03_eof_rule.re"
    "examples/go/eof/05_generic_api_eof_rule.re"
    "examples/go/fill/01_fill.re"
    "examples/go/fill/02_fill.re"
    "examples/go/headers/header.re"
    "examples/go/headers/src/lexer/lexer.go"
    "examples/go/includes/include.re"
    "examples/go/includes/definitions.go"
    "examples/go/reuse/reuse.re"
    "examples/go/state/push.re"
    "examples/go/submatch/01_stags.re"
    "examples/go/submatch/02_mtags.re"
    "examples/go/submatch/03_posix.re"
)
re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_c}"  "${re2c_manpage_bootstrap_c}"  "c")
re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_go}" "${re2c_manpage_bootstrap_go}" "go")
re2c_gen_help("${re2c_help_source}" "${re2c_help}" "${re2c_help_bootstrap}")
add_custom_target(docs DEPENDS "${re2c_docs}")

# install and test targets are enabled only if re2c is the root project
if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    # install
    if(UNIX)
        install(TARGETS re2c RUNTIME DESTINATION bin)
        install(FILES "${re2c_manpage_c}" DESTINATION "share/man/man1")
        if(RE2C_BUILD_RE2GO)
            install(TARGETS re2go RUNTIME DESTINATION bin)
            install(FILES "${re2c_manpage_go}" DESTINATION "share/man/man1")
        endif()
        install(FILES include/unicode_categories.re DESTINATION "${RE2C_STDLIB_DIR}")
    endif()

    # rebuild all re2c sources using newly built re2c
    add_custom_target(bootstrap
        COMMAND cmake -E remove_directory "src"
        COMMAND cmake -E remove_directory "doc"
        COMMAND cmake --build "${CMAKE_CURRENT_BINARY_DIR}"
    )

    # tests
    add_custom_target(tests
        DEPENDS "${RE2C_RUN_TESTS}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        COMMAND "${RE2C_RUN_TESTS}"
    )
    add_dependencies(tests re2c)
    add_custom_target(vtests
        DEPENDS "${RE2C_RUN_TESTS}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        COMMAND "${RE2C_RUN_TESTS}" --valgrind

=== debian/changelog ===
re2c (2.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Patches: remove 01 (fix released upstream), refresh 02.
  * Copyright:
    + account for renamed test files.
    + update current upstream maintainer info.
  * Control: refresh description, mention newly added support for Go.
  * Rules: don't install the __run_all scripts with the examples.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Mon, 24 Aug 2020 09:05:07 +0000

re2c (1.3-2) unstable; urgency=high

  [ JCF Ploemen (jcfp) ]
  * Control: add build-dep on python3-pygments, for use by rst2man.
  * Patches:
    + add 01, backport of the upstream fix for a heap-based buffer
      overflow in Scanner::fill in parse/scanner.cc.
      (CVE-2020-11958; closes: #963158)
    + add 02, fix for a manpage spelling error.
  * Rules: switch dh_auto_test override to execute_after.
  * Lintian: remove override for override_dh_auto_test-does-not-
    check-DEB_BUILD_OPTIONS, no longer needed.
  * Bump compat level to 13 (from 12; no further changes).

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.
  * Update standards version to 4.5.0, no changes needed.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Tue, 23 Jun 2020 14:18:11 +0000

=== debian/control ===
Source: re2c
Section: devel
Priority: optional
Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
Build-Depends:
 bison,
 debhelper-compat (= 13),
 python3-docutils,
 python3-pygments
Standards-Version: 4.5.0
Homepage: https://re2c.org
Vcs-Git: https://salsa.debian.org/jcfp/re2c.git
Vcs-Browser: https://salsa.debian.org/jcfp/re2c

Package: re2c
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lexer generator for C, C++ and Go
 re2c's main goal is generating fast lexers: at least as fast as
 their reasonably optimized hand-coded counterparts. Instead of using
 a traditional table-driven approach, re2c encodes the generated
 finite state automata directly in the form of conditional jumps and
 comparisons. The resulting programs are faster and often smaller
 than their table-driven analogues, and they are much easier to debug
 and understand. Quite a few optimizations are applied in order to
 speed up and compress the generated code.
 .
 Another distinctive feature is its flexible interface: instead of
 assuming a fixed program template, re2c lets the programmer write
 most of the interface code and adapt the generated lexer to any
 particular environment.

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,13 @@
 %:
 	dh $@
 
-override_dh_auto_test:
-	dh_auto_test
+override_dh_auto_configure:
+	dh_auto_configure -- --enable-docs
+
+execute_after_dh_installexamples:
+	rm -f debian/re2c/usr/share/doc/re2c/examples/c/__run_all.sh
+	rm -f debian/re2c/usr/share/doc/re2c/examples/go/__run_all.sh
+
+execute_after_dh_auto_test:
 	# ensure failed tests are visible in the buildlog
 	/bin/sh -c 'cat test-suite.log || true'
-
-override_dh_compress:
-	dh_compress -X examples/

## re2c 2.2

=== debian/changelog ===
re2c (2.2-1deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:17:45 +0800

re2c (2.2-1) unstable; urgency=medium

  * New upstream release.
  * Change maintainer to my debian.org email address.
  * Bump Standards-Version to 4.6.0 (from 4.5.1; no further changes).
  * Rules: add override for dh_auto_test to ensure Python
    multiprocessing.Pool() is supported, and otherwise skip the
    testsuite.
  * Tests: upstream switched testsuite to Python3, adjust the
    autopkgtest accordingly.
  * Control: build-depend on python3 for the upstream testsuite.

 -- Jeroen Ploemen <jcfp@debian.org>  Thu, 19 Aug 2021 10:17:21 +0000

re2c (2.1.1-1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.1 (from 4.5.0; no further changes).
  * Watch: bump version to 4.
  * Control: add Rules-Requires-Root: no.
  * Patches: expand 02 to cover fresh new typos.

 -- Jeroen Ploemen <jcfp@debian.org>  Wed, 07 Jul 2021 09:20:41 +0000

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,12 @@
 	rm -f debian/re2c/usr/share/doc/re2c/examples/c/__run_all.sh
 	rm -f debian/re2c/usr/share/doc/re2c/examples/go/__run_all.sh
 
+override_dh_auto_test:
+	# testsuite requires Python multiprocessing.Pool()
+	/bin/sh -c 'python3 -c "from multiprocessing import Pool; pool = Pool(); pool.close()" \
+		&& dh_auto_test \
+		|| echo "Support for multiprocessing.Pool() missing, skipping testsuite"'
+
 execute_after_dh_auto_test:
 	# ensure failed tests are visible in the buildlog
 	/bin/sh -c 'cat test-suite.log || true'

=== debian/watch ===
version=4
https://github.com/skvadrik/re2c/releases .*/re2c-(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## re2c 3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,64 +1,60 @@
 cmake_minimum_required(VERSION 3.12)
-project(re2c VERSION 2.0.3 HOMEPAGE_URL "https://re2c.org/")
+project(re2c VERSION 3.0 HOMEPAGE_URL "https://re2c.org/")
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
 include(Re2cAutotoolsHelpers)
 include(Re2cBootstrapLexer)
 include(Re2cBootstrapParser)
+include(Re2cBuildType)
 include(Re2cGenDocs)
-include(Re2cTryCXXFlag)
+include(Re2cCompilerFlags)
 
 ac_subst(PACKAGE_VERSION "${PROJECT_VERSION}")
 
 option(RE2C_REBUILD_LEXERS "Regenerate lexers" OFF)
 if(RE2C_REBUILD_LEXERS AND NOT RE2C_FOR_BUILD)
-    message(FATAL_ERROR "need RE2C_FOR_BUILD for RE2C_REBUILD_LEXERS")
+    message(FATAL_ERROR "option RE2C_FOR_BUILD is required for RE2C_REBUILD_LEXERS")
 endif()
 
 option(RE2C_REBUILD_DOCS "Regenerate manpage" OFF)
 if(RE2C_REBUILD_DOCS)
     find_program(RST2MAN NAMES rst2man rst2man.py)
     if(NOT RST2MAN)
-        message(FATAL_ERROR "need rst2man or rst2man.py for RE2C_REBUILD_DOCS")
+        message(FATAL_ERROR "rst2man (or rst2man.py) program is required for RE2C_REBUILD_DOCS")
     endif()
+
+    # Windows does not have a native 'man' and 'sed' commands.
+    # Therefore, we are looking for the Cygwin versions of 'man' and 'sed'.
+    if (WIN32)
+        find_program(MAN_EXECUTABLE man)
+        if(NOT MAN_EXECUTABLE)
+            message(FATAL_ERROR "man program is required for RE2C_REBUILD_DOCS")
+        endif()
+
+        find_program(SED_EXECUTABLE sed)
+        if(NOT SED_EXECUTABLE)
+            message(FATAL_ERROR "sed program is required for RE2C_REBUILD_DOCS")
+        endif()
+    endif()
 endif()
 
 option(RE2C_BUILD_LIBS "Build libraries" OFF)
 
 option(RE2C_BUILD_RE2GO "Build re2go executable (an alias for `re2c --lang go`)" ON)
+option(RE2C_BUILD_RE2RUST "Build re2rust executable (an alias for `re2c --lang rust`)" ON)
+
+option(RE2C_BUILD_BENCHMARKS "Build benchmarks" OFF)
+option(RE2C_REGEN_BENCHMARKS "Regenerate C code for benchmarks" OFF)
 
 # checks for programs
 find_package(BISON)
+find_package(Python3 COMPONENTS Interpreter)
 
 # checks for C++ compiler flags
 set(CMAKE_CXX_STANDARD 98)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON) # make sure object libraries work with shared libraries
-if(NOT CMAKE_BUILD_TYPE)
-    try_cxxflag("-O2")
-endif()
-try_cxxflag("-W")
-try_cxxflag("-Wall")
-try_cxxflag("-Wextra")
-try_cxxflag("-Weffc++")
-try_cxxflag("-pedantic")
-try_cxxflag("-Wformat=2")
-try_cxxflag("-Wredundant-decls")
-try_cxxflag("-Wsuggest-attribute=format")
-try_cxxflag("-Wconversion")
-try_cxxflag("-Wsign-conversion")
-try_cxxflag("-Werror=return-type")
-try_cxxflag("-Weverything"
-    "-Wno-unknown-warning-option" # CLANG eats some GCC options only to warn they are unknown
-    "-Wno-reserved-id-macro" # to allow header guards of the form '_RE2C_PATH_TO_HEADER_BASENAME_'
-    "-Wno-padded"
-    "-Wno-old-style-cast" # RE2C-generated lexer has lots of C-syle casts because of 're2c:yych:conversion = 1;'
-    "-Wno-nested-anon-types"
-    "-Wno-global-constructors" # initialization of global constants with std::numeric_limits<...> (mostly for size_t)
-    "-Wno-shadow-field-in-constructor" # using same names in ctor seems more like a feature
-    "-Wno-undefined-func-template" # explicit specialization to reduce build dependencies
-)
-try_cxxflag("-fdiagnostics-color=always")
 
 # use system stdint.h if present, otherwise fallback to src/c99_stdint.h
 ac_check_headers("stdint.h")
@@ -101,11 +97,14 @@
 )
 
 set(top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")
+set(top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
+set(PYTHON "${Python3_EXECUTABLE}")
+
 configure_file(doc/manpage.rst.in doc/manpage.rst @ONLY)
 configure_file(doc/help.rst.in doc/help.rst @ONLY)
 
-configure_file(run_tests.sh.in run_tests.sh @ONLY)
-set(RE2C_RUN_TESTS "${CMAKE_CURRENT_BINARY_DIR}/run_tests.sh")
+configure_file(run_tests.py.in run_tests.py @ONLY)
+set(RE2C_RUN_TESTS "${CMAKE_CURRENT_BINARY_DIR}/run_tests.py")
 if(CMAKE_HOST_UNIX)
     execute_process(COMMAND chmod +x "${RE2C_RUN_TESTS}")
 endif()
@@ -147,12 +146,13 @@
     src/codegen/gen_program.cc
     src/codegen/gen_state.cc
     src/codegen/helpers.cc
+    src/codegen/remove_empty.cc
     src/codegen/render.cc
     src/options/opt.cc
+    src/options/symtab.cc
     src/nfa/estimate_size.cc
     src/nfa/re_to_nfa.cc
     src/adfa/adfa.cc
-    src/adfa/prepare.cc
     src/debug/dump_adfa.cc
     src/debug/dump_cfg.cc
     src/debug/dump_dfa.cc
@@ -192,6 +192,7 @@
     src/regexp/default_tags.cc
     src/regexp/fixed_tags.cc
     src/regexp/nullable.cc
+    src/regexp/re.cc
     src/regexp/rule.cc
     src/regexp/split_charset.cc
     src/regexp/tag.cc
@@ -203,11 +204,10 @@
     src/skeleton/skeleton.cc
     src/parse/ast.cc
     src/parse/input.cc
-    src/parse/normalize.cc
+    src/parse/parse.cc
     src/parse/scanner.cc
     src/parse/unescape.cc
-    src/parse/validate.cc
-    src/util/get_dir.cc
+    src/util/file_utils.cc
     src/util/s_to_n32_unsafe.cc
     src/util/temp_file.cc
     src/util/range.cc
@@ -225,6 +225,12 @@
     target_compile_definitions(re2go PUBLIC "RE2C_LANG=LANG_GO")
 endif()
 
+# re2rust
+if (RE2C_BUILD_RE2RUST)
+    add_executable(re2rust ${re2c_sources})
+    target_compile_definitions(re2rust PUBLIC "RE2C_LANG=LANG_RUST")
+endif()
+
 re2c_bootstrap_lexer("src/parse/lex.re" "src/parse/lex.cc" "src/parse/lex.h")
 re2c_bootstrap_lexer("src/parse/lex_conf.re" "src/parse/lex_conf.cc")
 re2c_bootstrap_lexer("src/options/parse_opts.re" "src/options/parse_opts.cc")
@@ -234,8 +240,8 @@
 # docs
 set(re2c_docs_sources
     "${re2c_manpage_source}"
-    "doc/manual/api/api.rst_"
     "doc/manual/api/interface.rst_"
+    "doc/manual/conditions/blocks.rst_"
     "doc/manual/conditions/conditions.rst_"
     "doc/manual/configurations/configurations.rst_"
     "doc/manual/directives/directives.rst_"
@@ -260,13 +266,24 @@
     "doc/manual/state/state.rst_"
     "doc/manual/submatch/submatch_example_mtags.rst_"
     "doc/manual/submatch/submatch_example_posix.rst_"
+    "doc/manual/submatch/submatch_example_stags_fill.rst_"
     "doc/manual/submatch/submatch_example_stags.rst_"
     "doc/manual/submatch/submatch.rst_"
+    "doc/manual/synopsis.rst_"
+    "doc/manual/syntax/api1.rst_"
+    "doc/manual/syntax/api2_c.rst_"
+    "doc/manual/syntax/api2_go.rst_"
+    "doc/manual/syntax/api2_rust.rst_"
+    "doc/manual/syntax/api3.rst_"
+    "doc/manual/syntax/intro.rst_"
     "doc/manual/syntax/syntax.rst_"
     "doc/manual/warnings/warnings_general.rst_"
     "doc/manual/warnings/warnings_list.rst_"
     "examples/c/01_basic.re"
+    "examples/c/01_basic.c"
+    "examples/c/conditions/parse_u32_blocks.re"
     "examples/c/conditions/parse_u32_conditions.re"
+    "examples/c/encodings/unicode_identifier.re"
     "examples/c/eof/01_sentinel.re"
     "examples/c/eof/02_bounds_checking.re"
     "examples/c/eof/03_eof_rule.re"
@@ -274,16 +291,21 @@
     "examples/c/fill/01_fill.re"
     "examples/c/fill/02_fill.re"
     "examples/c/headers/header.re"
-    "examples/c/headers/src/lexer/lexer.h"
+    "examples/c/headers/lexer/state.h"
     "examples/c/includes/include.re"
     "examples/c/includes/definitions.h"
     "examples/c/reuse/reuse.re"
+    "examples/c/reuse/usedir.re"
     "examples/c/state/push.re"
+    "examples/c/submatch/01_stags_fill.re"
     "examples/c/submatch/01_stags.re"
     "examples/c/submatch/02_mtags.re"
     "examples/c/submatch/03_posix.re"
     "examples/go/01_basic.re"
+    "examples/go/01_basic.go"
+    "examples/go/conditions/parse_u32_blocks.re"
     "examples/go/conditions/parse_u32_conditions.re"
+    "examples/go/encodings/unicode_identifier.re"
     "examples/go/eof/01_sentinel.re"
     "examples/go/eof/02_bounds_checking.re"
     "examples/go/eof/03_eof_rule.re"
@@ -291,48 +313,32 @@
     "examples/go/fill/01_fill.re"
     "examples/go/fill/02_fill.re"
     "examples/go/headers/header.re"
-    "examples/go/headers/src/lexer/lexer.go"
+    "examples/go/headers/lexer/state.go"
     "examples/go/includes/include.re"
     "examples/go/includes/definitions.go"
     "examples/go/reuse/reuse.re"
+    "examples/go/reuse/usedir.re"
     "examples/go/state/push.re"
+    "examples/go/submatch/01_stags_fill.re"
     "examples/go/submatch/01_stags.re"
     "examples/go/submatch/02_mtags.re"
     "examples/go/submatch/03_posix.re"
-)
-re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_c}"  "${re2c_manpage_bootstrap_c}"  "c")
-re2c_gen_manpage("${re2c_manpage_source}" "${re2c_manpage_go}" "${re2c_manpage_bootstrap_go}" "go")
-re2c_gen_help("${re2c_help_source}" "${re2c_help}" "${re2c_help_bootstrap}")
-add_custom_target(docs DEPENDS "${re2c_docs}")
-
-# install and test targets are enabled only if re2c is the root project
-if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
-    # install
-    if(UNIX)
-        install(TARGETS re2c RUNTIME DESTINATION bin)
-        install(FILES "${re2c_manpage_c}" DESTINATION "share/man/man1")
-        if(RE2C_BUILD_RE2GO)
-            install(TARGETS re2go RUNTIME DESTINATION bin)
-            install(FILES "${re2c_manpage_go}" DESTINATION "share/man/man1")
-        endif()
-        install(FILES include/unicode_categories.re DESTINATION "${RE2C_STDLIB_DIR}")
-    endif()
-
-    # rebuild all re2c sources using newly built re2c
-    add_custom_target(bootstrap
-        COMMAND cmake -E remove_directory "src"
-        COMMAND cmake -E remove_directory "doc"
-        COMMAND cmake --build "${CMAKE_CURRENT_BINARY_DIR}"
-    )
-
-    # tests
-    add_custom_target(tests
-        DEPENDS "${RE2C_RUN_TESTS}"
-        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-        COMMAND "${RE2C_RUN_TESTS}"
-    )
-    add_dependencies(tests re2c)
-    add_custom_target(vtests
-        DEPENDS "${RE2C_RUN_TESTS}"
-        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-        COMMAND "${RE2C_RUN_TESTS}" --valgrind
+    "examples/rust/01_basic.re"
+    "examples/rust/01_basic.rs"
+    "examples/rust/conditions/parse_u32_blocks.re"
+    "examples/rust/conditions/parse_u32_conditions.re"
+    "examples/rust/encodings/unicode_identifier.re"
+    "examples/rust/eof/01_sentinel.re"
+    "examples/rust/eof/02_bounds_checking.re"
+    "examples/rust/eof/03_eof_rule.re"
+    "examples/rust/eof/05_generic_api_eof_rule.re"
+    "examples/rust/fill/01_fill.re"
+    "examples/rust/fill/02_fill.re"
+    "examples/rust/headers/header.re"
+    "examples/rust/headers/lexer/state.rs"
+    "examples/rust/includes/include.re"
+    "examples/rust/includes/definitions.rs"
+    "examples/rust/reuse/reuse.re"
+    "examples/rust/reuse/usedir.re"
+    "examples/rust/state/push.re"
+    "examples/rust/submatch/01_stags_fill.re"

=== debian/changelog ===
re2c (3.0-1) unstable; urgency=medium

  * New upstream version 3.0
  * Tests: also symlink re2go, re2rust in upstream-runtests.
  * Patches: refresh 02 (mostly merged upstream).
  * Rules: also remove __run_all script from rust examples.
  * Lintian: add override to ignore long lines in test data.
  * Control: update short description to mention Rust support.

 -- Jeroen Ploemen <jcfp@debian.org>  Thu, 03 Feb 2022 12:01:46 +0000

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: re2c
 Section: devel
 Priority: optional
-Maintainer: JCF Ploemen (jcfp) <linux@jcf.pm>
+Maintainer: Jeroen Ploemen <jcfp@debian.org>
 Build-Depends:
  bison,
  debhelper-compat (= 13),
+ python3 <!nocheck>,
  python3-docutils,
  python3-pygments
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://re2c.org
 Vcs-Git: https://salsa.debian.org/jcfp/re2c.git
 Vcs-Browser: https://salsa.debian.org/jcfp/re2c
+Rules-Requires-Root: no
 
 Package: re2c
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: lexer generator for C, C++ and Go
+Description: lexer generator for C, C++, Go and Rust
  re2c's main goal is generating fast lexers: at least as fast as
  their reasonably optimized hand-coded counterparts. Instead of using
  a traditional table-driven approach, re2c encodes the generated

=== debian/rules ===
--- 
+++ 
@@ -5,15 +5,18 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+# Ensure the build is reproducible
+export LC_ALL=C.UTF-8
+export LANGUAGE=C.UTF-8
+
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-docs
 
-execute_after_dh_installexamples:
-	rm -f debian/re2c/usr/share/doc/re2c/examples/c/__run_all.sh
-	rm -f debian/re2c/usr/share/doc/re2c/examples/go/__run_all.sh
+override_dh_installexamples:
+	dh_installexamples --exclude=__run_all.sh
 
 override_dh_auto_test:
 	# testsuite requires Python multiprocessing.Pool()

=== debian/tests/control ===
Tests: upstream-runtests
Depends: @, build-essential, debhelper, dh-autoreconf, python3
Restrictions: rw-build-tree
